<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Kalligraphie</title>
    <script type="module">
        import { LitElement, svg, css, html } from 'https://unpkg.com/lit-element/lit-element.js?module';
    
        class Kalligraphie extends LitElement
        {
            static get properties()
            {
                return {
                    paths: { type: Array },
                    linetime: {type: Number}
                }
            }

            constructor()
            {
                super();
                this.paths = [];

                var maxStrength = 50;
                var minStrength = 5;
                var smoothness = 50;
                var strengthFunction = (speed) => 
                {
                    return (maxStrength - minStrength) * Math.pow(Math.E, - speed / smoothness) + minStrength;
                }
                this.linetime = Date.now();
                var pointtime = Date.now();
                this.moving = false;
                this.addEventListener('mousedown', e => {
                    this.moving = true;
                    pointtime = Date.now();
                    var curlinetime = Date.now() - this.linetime;
                    this.paths.push(
                        {
                            points: [],
                            time: curlinetime
                        })
                });
                this.addEventListener('mouseup', e => {
                    this.moving = false;
                });
                this.addEventListener('mousemove', event => {
                    if ( this.moving ){
                        var index = this.paths.length - 1;
                        this.paths[index].points.push({x: event.x, y: event.y, strength: 5, time: Date.now() - this.linetime});
                        var curpathlength = this.paths[index].points.length;

                        if(curpathlength > 1)
                        {
                            var tdiff = (Date.now() - pointtime) / 10;
                            var xdiff = this.paths[index].points[curpathlength-2].x - this.paths[index].points[curpathlength-1].x;
                            var ydiff = this.paths[index].points[curpathlength-2].y - this.paths[index].points[curpathlength-1].y;
                            var diff = Math.sqrt((xdiff * xdiff) + (ydiff * ydiff));
                            this.paths[index].points[curpathlength-2].strength = strengthFunction(diff/tdiff);
                            pointtime = Date.now();
                        }                        
                        super.update();
                    }
                });
            }

            render()
            {
                return html`
                    <div id="container">
                        <button @click="${this.replay}">Replay</button>
                        <button @click="${this.clear}">Clear</button>
                    </div>
                    <div style="cursor: text; border: thin solid black">                        
                        <svg width="100%" height="500">
                            ${this.paths.map((path) => {
                                var points = "";
                                for(var i = 0; i < path.points.length; i++)
                                {
                                    if(i > 0)
                                        points += " ";
                                    points += path.points[i].x + "," + (path.points[i].y - path.points[i].strength/2);
                                }
                                if(path.points.length > 1)
                                {
                                    for(var i = path.points.length-1; i >= 0; i--)
                                    {              
                                        points += " ";
                                        points += path.points[i].x + "," + (path.points[i].y + path.points[i].strength/2);
                                    }
                                }
                                return svg`<polyline points="${points}" fill="gray" stroke="black" stroke-width="1"/>`;
                            })}
                        </svg>
                    </div>
                `;
            }

            clear()
            {
                this.paths = [];
                this.linetime = Date.now();
            }

            replay()
            {
                var pathReplay = this.paths;
                this.paths = [];                     
                var index = 0;
                pathReplay.forEach(path => {
                    if(path.points.length > 0)
                    {
                        setTimeout(() => {
                            this.paths.push(
                            {
                                points: [],
                                time: path.time
                            })
                            path.points.forEach(point => {
                                setTimeout(() => {
                                    this.paths[this.paths.length-1].points.push({x: point.x, y: point.y, strength: point.strength, time: point.strength});
                                    super.update();
                                }, point.time);
                            });
                            index++;
                        }, path.time);
                    }
                });
            }
        }


        customElements.define('kalligraphie-base', Kalligraphie)
        var kalligraphie = document.createElement('kalligraphie-base');
        document.querySelector('body').appendChild(kalligraphie);
    </script>
</head>
<body>        
</body>
</html>